//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  GDI+ Save\bhMIME TYPEGUIDw肵ĕʂ̉摜`ŕۑ
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2012N1202 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GDIPAPI, GDIPOBJ, GDIPUTIL, StdCtrls, ExtCtrls, ExtDlgs;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    OpenDialog1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private 錾 }
    FImageFilePath : string;
    FLoadFilePath  : string;
    FSaveFilePath  : string;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.emf;*.wmf;*.ico' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.emf|*.emf' +
    '|*.wmf|*.wmf' +
    '|*.ico|*.ico';

//=============================================================================
//  tH[̏
//  摜t@C̓ǂݏotH_ƁCۑ̃tH_f~^tŐݒ
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Caption := 'GDI+  e摜`ɕϊĕۑ';

  FLoadFilePath := ExtractFilePath(ParamStr(0)) + 'OriginalImages';
  FLoadFilePath := IncludeTrailingPathDelimiter(FLoadFilePath);

  FSaveFilePath := ExtractFilePath(ParamStr(0)) + 'ChangedImages';
  FSaveFilePath := IncludeTrailingPathDelimiter(FSaveFilePath);
end;

//=============================================================================
//  摜t@CǂݏoāCe`ŕۑ
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LGPBitmap     : TGPBitmap;
  LSaveFilePath : string;
  LFileName     : string;
  LImgGUID      : TGUID;
begin
  if OpenDialog1.InitialDir = '' then begin
    OpenDialog1.InitialDir := ExtractFileDir(FLoadFilePath);
  end;

  OpenDialog1.Filter := OpenFileFilter;
  if OpenDialog1.Execute then begin
    FImageFilePath := OpenDialog1.FileName;
    LGPBitmap      := TGPBitmap.Create(FImageFilePath);

    LFileName     := ExtractFileName(FImageFilePath);
    LSaveFilePath  := FSaveFilePath + LFileName;
    Label1.Caption := LFileName;
    Label2.Caption := '  .bmp,  .jpg,  .gif,   .png,  .tif ';

    //wMIME^CvGUID߁Cǂݏot@C̊gqύXĕۑ
    //rbg}bv摜Ƃĕۑ
    if GetEncoderClsid('image/bmp', LImgGUID) >= 0 then begin
      LGPBitmap.Save(ChangeFileExt(LSaveFilePath, '.bmp'), LImgGUID);
    end;

    //JPEG摜Ƃĕۑ
    if GetEncoderClsid('image/jpeg', LImgGUID) >= 0 then begin
      LGPBitmap.Save(ChangeFileExt(LSaveFilePath, '.jpg'), LImgGUID);
    end;

    //GIF摜Ƃĕۑ
    if GetEncoderClsid('image/gif', LImgGUID) >= 0 then begin
      LGPBitmap.Save(ChangeFileExt(LSaveFilePath, '.gif'), LImgGUID);
    end;

    //PNG摜Ƃĕۑ
    if GetEncoderClsid('image/png', LImgGUID) >= 0 then begin
      LGPBitmap.Save(ChangeFileExt(LSaveFilePath, '.png'), LImgGUID);
    end;

    //TIFF摜Ƃĕۑ
    if GetEncoderClsid('image/tiff', LImgGUID) >= 0 then begin
      LGPBitmap.Save(ChangeFileExt(LSaveFilePath, '.tif'), LImgGUID);
    end;

    LGPBitmap.Free;
    Invalidate;
  end;
end;

//=============================================================================
//  tH[OnPaintCxg
//  ǂݏo摜ƁCۑ摜ǂݏoĕ`
//=============================================================================
//  GetImageEncodersSize
procedure TForm1.FormPaint(Sender: TObject);
var
  LLoadFilePath : string;
  LFileName     : string;
  LGPGraphic    : TGPGraphics;
  LGPImage      : TGPImage;
  LWidth        : Integer;
  LHeight       : Integer;
  LLeft         : Integer;
  LTop          : Integer;
begin
  if FImageFilePath = '' then exit;

  LFileName      := ExtractFileName(FImageFilePath);
  LLoadFilePath  := FSaveFilePath + LFileName;

  LWidth  := 110;
  LHeight := 110;
  LLeft   := 10;
  LTop    := 40;

  //ϊ̉摜t@CTGPImage𐶐
  LGPImage   := TGPImage.Create(FImageFilePath);
  //`͂CanvasƂ
  LGPGraphic := TGPGraphics.Create(Canvas.Handle);

  //̉摜`
  LGPGraphic.DrawImage(LGPImage, MakeRect(LLeft, LTop, LWidth, LHeight));

  LGPImage.Free;
  LGPGraphic.Free;


  //\ʒuݒ肵...
  LLeft := 10;
  LTop  := 160;
  //摜̌`ϊĕۑt@Cǂݏoĕ\
  //rbg}bv摜ɕϊ摜
  LGPImage   := TGPImage.Create(ChangeFileExt(LLoadFilePath, '.bmp'));
  LGPGraphic := TGPGraphics.Create(Canvas.Handle);
  LGPGraphic.DrawImage(LGPImage, MakeRect(LLeft, LTop, LWidth, LHeight));

  LGPImage.Free;
  LGPGraphic.Free;


  LLeft := LLeft + LWidth + 10;
  //JPEG摜ɕϊ摜
  LGPImage   := TGPImage.Create(ChangeFileExt(LLoadFilePath, '.jpg'));
  LGPGraphic := TGPGraphics.Create(Canvas.Handle);
  LGPGraphic.DrawImage(LGPImage, MakeRect(LLeft, LTop, LWidth, LHeight));

  LGPImage.Free;
  LGPGraphic.Free;


  LLeft := LLeft + LWidth + 10;
  //GIF摜ɕϊ摜
  LGPImage   := TGPImage.Create(ChangeFileExt(LLoadFilePath, '.gif'));
  LGPGraphic := TGPGraphics.Create(Canvas.Handle);
  LGPGraphic.DrawImage(LGPImage, MakeRect(LLeft, LTop, LWidth, LHeight));

  LGPImage.Free;
  LGPGraphic.Free;


  LLeft := LLeft + LWidth + 10;
  //PNG摜ɕϊ摜
  LGPImage   := TGPImage.Create(ChangeFileExt(LLoadFilePath, '.png'));
  LGPGraphic := TGPGraphics.Create(Canvas.Handle);
  LGPGraphic.DrawImage(LGPImage, MakeRect(LLeft, LTop, LWidth, LHeight));

  LGPImage.Free;
  LGPGraphic.Free;


  LLeft := LLeft + LWidth + 10;
  //TIFF摜ɕϊ摜
  LGPImage   := TGPImage.Create(ChangeFileExt(LLoadFilePath, '.tif'));
  LGPGraphic := TGPGraphics.Create(Canvas.Handle);
  LGPGraphic.DrawImage(LGPImage, MakeRect(LLeft, LTop, LWidth, LHeight));

  LGPImage.Free;
  LGPGraphic.Free;
end;

end.
